CifDensityReader
Date: 2019-10-22

org.jmol.jvxl.readers

## Class CifDensityReader

- java.lang.Object
- - org.jmol.jvxl.readers.SurfaceReader
  - - org.jmol.jvxl.readers.SurfaceFileReader
    - - org.jmol.jvxl.readers.VolumeFileReader
      - - org.jmol.jvxl.readers.MapFileReader
        - - org.jmol.jvxl.readers.BCifDensityReader
          - - org.jmol.jvxl.readers.CifDensityReader

- All Implemented Interfaces:
    VertexDataServer

      class CifDensityReader
      extends BCifDensityReader

  CIF density reader. See https://www.ebi.ac.uk/pdbe/densities/x-ray/1eve/box, for example: https://www.ebi.ac.uk/pdbe/densities/x-ray/1eve/box/-4.413,55.607,64.124/-0.4130001,59.607,68.124?space=cartesian&encoding=cif Extends BCifDensityReader just enough to handle nonbinary CIF data.

- - ### Field Summary

    - ### Fields inherited from class org.jmol.jvxl.readers.BCifDensityReader

      `checkSum, cifData, thisData, values`

    - ### Fields inherited from class org.jmol.jvxl.readers.MapFileReader

      `a, alpha, b, beta, c, dmax, dmean, dmin, drange, gamma, mapc, mapr, maps, mode, n0, n1, n2, na, nb, nc, origin, p3, vectors, xIndex, xyzStart, yIndex, zIndex`

    - ### Fields inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `ac, boundingBox, canDownsample, downsampleFactor, downsampleRemainders, endOfData, isAngstroms, nData, negativeAtomCount, nSkipX, nSkipY, nSkipZ, nSurfaces, readerClosed`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `binarydoc, br, line, next, out`

    - ### Fields inherited from class org.jmol.jvxl.readers.SurfaceReader

      `allowSigma, ANGSTROMS_PER_BOHR, anisotropy, center, cJvxlEdgeNaN, colorFractionBase, colorFractionRange, contourVertexCount, dataMax, dataMean, dataMin, defaultCutoff, defaultMappedDataMax, defaultMappedDataMin, eccentricityMatrix, eccentricityMatrixInverse, eccentricityRatio, eccentricityScale, edgeFractionBase, edgeFractionRange, fractionData, hasColorData, haveSurfaceAtoms, isAnisotropic, isEccentric, isJvxl, isPeriodic, isProgressive, isQuiet, isXLowToHigh, jvxlColorDataRead, jvxlCutoff, jvxlData, jvxlDataIs2dContour, jvxlDataIsColorDensity, jvxlDataIsColorMapped, jvxlDataIsPrecisionColor, jvxlEdgeDataRead, jvxlFileHeaderBuffer, jvxlNSurfaceInts, jvxlVoxelBitSet, marchingCubes, marchingSquares, meshData, meshDataServer, minMax, nBytes, nDataPoints, nPointsX, nPointsY, nPointsZ, params, ptTemp, qpc, sg, vertexDataOnly, volumeData, volumetricOrigin, volumetricVectors, voxelCounts, voxelData, xyzMax, xyzMin, yzCount, yzPlanes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CifDensityReader()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `getCifData(java.lang.String fileName, java.lang.Object data)`
    `protected float` | `getCifFloat(java.lang.String key)`
    `protected java.util.Map<java.lang.String,java.lang.Object>` | `getCifMap(java.lang.String type)`
    `protected float[]` | `readCifFloats(java.lang.String key, float[] values)`
    `protected javajs.util.P3` | `readCifP3(java.lang.String key, javajs.util.P3 p3)`

    - ### Methods inherited from class org.jmol.jvxl.readers.BCifDensityReader

      `closeReader, getCifString, init2, nextVoxel, readParameters, skipData`

    - ### Methods inherited from class org.jmol.jvxl.readers.MapFileReader

      `checkInsideOut, getVectorsAndOrigin, init2MFR, setCutoffAutomatic`

    - ### Methods inherited from class org.jmol.jvxl.readers.VolumeFileReader

      `checkAtomLine, getNextVoxelValue, getPlane, getPlaneNCI, getSPFv, getSurfacePointAndFraction, getValue, getVoxelBitSet, gotoData, init2VFR, initializeSurfaceData, readSurfaceData, readSurfaceDataVFR, readVolumeData, readVolumeDataVFR, readVolumeParameters, readVoxelVector, recordData, skipComments, skipDataVFR, swapXZ`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceFileReader

      `closeReaderSFR, discardTempData, getQuotedStringNext, getTokens, init, init2SFR, newBinaryDocument, parseFloat, parseFloatArray, parseFloatArrayStr, parseFloatRange, parseFloatStr, parseInt, parseIntNext, parseIntStr, rd, setOutputChannel, setStream, skipTo`

    - ### Methods inherited from class org.jmol.jvxl.readers.SurfaceReader

      `addTriangleCheck, addVC, addVertexCopy, applyColorScale, colorIsosurface, createIsosurface, discardTempDataSR, excludeMaximumSet, excludeMinimumSet, finalizeMapping, getColorPhaseIndex, getMinMaxMappedValues, getPlaneSR, getSPF, getSurfaceAtomIndex, getSurfacePointIndexAndFraction, getValue2, getValueAtPoint, gotoAndReadVoxelData, initializeMapping, initializeVolumetricData, initPlanes, initSR, jvxlUpdateInfo, newVoxelDataCube, postProcessVertices, readAndSetVolumeParameters, readColorData, resetIsosurface, selectPocket, setBBox, setVectorAnisotropy, setVertexAnisotropy, setVolumeDataV, setVolumetricAnisotropy, setVolumetricOriginAnisotropy, slabIsosurface, updateSurfaceData, updateTriangles`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CifDensityReader

          CifDensityReader()

  - ### Method Detail

    - #### getCifData

          protected void getCifData(java.lang.String fileName,
                                    java.lang.Object data)

      Overrides:
        `getCifData` in class `BCifDensityReader`

    - #### readCifP3

          protected javajs.util.P3 readCifP3(java.lang.String key,
                                             javajs.util.P3 p3)

      Overrides:
        `readCifP3` in class `BCifDensityReader`

    - #### getCifMap

          protected java.util.Map<java.lang.String,java.lang.Object> getCifMap(java.lang.String type)

      Overrides:
        `getCifMap` in class `BCifDensityReader`

    - #### getCifFloat

          protected float getCifFloat(java.lang.String key)

      Overrides:
        `getCifFloat` in class `BCifDensityReader`

    - #### readCifFloats

          protected float[] readCifFloats(java.lang.String key,
                                          float[] values)

      Overrides:
        `readCifFloats` in class `BCifDensityReader`